﻿var aplikacja = angular.module('TodoApka', []);
aplikacja.factory('zadanieService', ['$http', function zadaniaFactory($http) {
    return {
        pobierzZadania: function pobierzZadania() {
            return $http.get('api/zadania');
        },
        klonujZadanie: function klonujZadanie(zadanie) {
            return {
                id: zadanie.id,
                opis: zadanie.opis,
                uwagi: zadanie.uwagi,
                data: zadanie.data
            };
        },
        skasujZadanie: function skasujZadanie(zadanie) {
            return $http.delete('api/zadanie/' + zadanie.id);
        },
        zapiszZadanie: function zapiszZadanie(zadanie) {
            if (zadanie.id == undefined) {
                return $http.post('api/zadania/', zadanie);
            } else {
                return $http.put('api/zadanie/' + zadanie.id, zadanie);
            }
        }
    };
}]);
aplikacja.controller('KontrolerZadan', ['$scope', 'zadanieService', function ($scope, zadanieService) {
    $scope.zadania = [];
    $scope.jeszczeNieMaDanych = true;
    $scope.noweZadanie = {};
    var edytowane = {};
    var trwaZapisywanieZmian = new Set();
    function pobierzZadaniaDoTabeli() {
        return zadanieService.pobierzZadania().success(function (zadania) {
            $scope.zadania = zadania;
            $scope.jeszczeNieMaDanych = false;
        });
    }
    $scope.zapiszNoweZadanie = function zapiszNoweZadanie(zadanie) {
        zadanieService.zapiszZadanie(zadanie).success(function () {
            pobierzZadaniaDoTabeli().success(function (zadania) {
                $scope.noweZadanie = {};
            });
        });
    };
    $scope.zapiszZmianyWZadaniu = function zapiszZmianyWZadaniu(zadanie) {
        trwaZapisywanieZmian.add(zadanie.id);
        zadanieService.zapiszZadanie(zadanie).success(function () {
            pobierzZadaniaDoTabeli().success(function (zadania) {
                delete edytowane[zadanie.id];
                trwaZapisywanieZmian.delete(zadanie.id);
            });
        });
    };
    $scope.skasujZadanie = function skasujZadanie(zadanie) {
        trwaZapisywanieZmian.add(zadanie.id);
        zadanieService.skasujZadanie(zadanie).success(function () {
            pobierzZadaniaDoTabeli().success(function (zadania) {
                trwaZapisywanieZmian.delete(zadanie.id);
            });
        });
    };
    $scope.edytujZadanie = function(zadanie) {
        edytowane[zadanie.id] = zadanieService.klonujZadanie(zadanie);
    };
    $scope.czyEdytowane = function(zadanie) {
        return edytowane[zadanie.id] != undefined;
    }
    $scope.edytowane = function(zadanie) {
        return edytowane[zadanie.id];
    }
    $scope.anulujZmianyWZadaniu = function(zadanie) {
        delete edytowane[zadanie.id];
    }
    $scope.czyTrwaZapisywanieZmian = function(zadanie) {
        return trwaZapisywanieZmian.has(zadanie.id);
    }
    pobierzZadaniaDoTabeli();
}]);
